define( 
  [   "jquery"
    
  ]
  , function(jQuery) {
"use strict";

function searchList()
{
};

searchList.prototype.draw = function( oControlHost )
{
	
  var och = oControlHost
    , o = och.configuration
    , data2 
    , elm = och.container
    , sel = document.createElement('select')
    , pmaxHeight = (o&&o["maxHeight"])?o["maxHeight"]:150
    , pmaxWidth = (o&&o["maxWidth"])?o["maxWidth"]:200
    , pBackgroundColor = (o&&o["backgroundColor"])?o["backgroundColor"]:'white'
    , pMultiple = (o&&o["multiple"])?o["multiple"]:false
    , param= (o&&o["parameter"])?o["parameter"]:'Parameter1'
    , hideOptions = (o&&o["hideOptions"])?o["hideOptions"]:false
    , oParameter = oControlHost.getParameter( param )
    , staticVals = o.staticValues
    , preselectedVals=[]
    , vals
    ; 
    
  //if hideOptions is set, hide the labels list
  if(hideOptions) $(elm).append( '<style>#'+elm.id+' .sol-current-selection{display:none}'
  +'#'+elm.id+' .sol-inner-container{background:'+pBackgroundColor+'}'  
  +'</style>');

  //this.m_input = elm.querySelector( 'select' );
  this.sel = sel;
  
  //after refresh, remember the values selected. we start by adding those values to an array
  if( oParameter && ( oParameter.values.length > 0 ) ){
    for(var i=0;i<oParameter.values.length;++i){
      preselectedVals.push(oParameter.values[i].use)
    }
  }; 
  
  //this.m_values='';
  $(elm).append(sel);
  elm.style.width=pmaxWidth+'px';
     
  $(sel).data('sol-name',param);

  this.param = param;
  this.sel = sel;

  data2 = this.data;
  if(!data2) data2=[];
  
  if(staticVals&&staticVals.length){
    for(var i=0;i<staticVals.length;++i){
      var obj = {};
      obj['type']='option';
      obj['value']=String(staticVals[i].use);
      obj['label']=String(staticVals[i].display?staticVals[i].display:staticVals[i].use);
      if(preselectedVals && $.inArray(String(staticVals[i].use),preselectedVals)>=0) obj['selected']='true';
      data2.push(obj);
    }
  }
            
  //Create link to sol.css
if(!document.getElementById('solcss')){
  var cssFile = document.createElement('link');
  cssFile.rel = 'stylesheet';
  cssFile.type = 'text/css';
  cssFile.id='solcss';
  cssFile.href = '/include/js/sol.css';
  document.getElementsByTagName('head')[0].appendChild(cssFile)
}


require(["/include/js/sol.js"],
  function(){
    $(sel).searchableOptionList({
      data:data2
      , maxHeight:pmaxHeight+'px'
      , multiple:pMultiple
      , showSelectAll: true
      , selectAllMaxItemsThreshold:1000
    , events:{onChange:
    function(sol){
        vals = sol.getSelection();
        
        if(vals.length==1) $(elm).find('input').attr("placeholder", vals[0].nextSibling.innerText);
        if(vals.length>1) $(elm).find('input').attr("placeholder", '(multiple)');
        if(!vals.length) $(elm).find('input').attr("placeholder", 'Click here to search');
      searchList.updated(och,vals)
    }
      , onInitialized:
        function(sol){
          var  changeText = function() {
            
            if($(elm).find(':text')[0].value.length>0) {
              $(elm).find('.sol-select-all').text('Check all matching');
              $(elm).find('.sol-deselect-all').text('Uncheck all matching');
            }
            if($(elm).find(':text')[0].value.length==0) {
              $(elm).find('.sol-select-all').text('Select all');
              $(elm).find('.sol-deselect-all').text('Select none');
            }
          };
          
          vals =  sol.getSelection();
       
          if(vals&&vals.length==1) $(elm).find('input').attr("placeholder", vals[0].nextSibling.innerText);
          if(vals&&vals.length>1) $(elm).find('input').attr("placeholder", '(multiple)');
          if(vals&&!vals.length) $(elm).find('input').attr("placeholder", 'Click here to search');

          if(!pMultiple) {
            
            $(elm).find('.sol-select-all').remove();
            $(elm).find('.sol-deselect-all').css('float','left');
          }
          else {
            $(elm).find(':text').keyup(changeText);
            $(elm).find(':text').mousedown(changeText);
            $(elm).find('a').click(changeText);
          }
  //          if(vals) searchList.updated(och,vals)*/
        }

    }
          
            
  })
}

);
    

};

searchList.updated = function(oControlHost, vals )
{
  this.m_values = vals
	oControlHost.valueChanged();
/*  if ( bAutoSubmit )
	{
		oControlHost.next();
	}*/
};

searchList.prototype.setData = function( oControlHost, oDataStore )
{
  
  
  var groupBy = function(xs, key) {
        return xs.reduce(function(rv, x) {
          (rv[x[key]] = rv[x[key]] || []).push(x);
          return rv;
        }, {});
        }
    , och = oControlHost
    , o = och.configuration
    , rowCount = oDataStore.rowCount
    , solJSON=[]
    , param= (o&&o["parameter"])?o["parameter"]:'Parameter1'
    , oParameter = oControlHost.getParameter( param )
    , preselectedVals = []
    , group = oDataStore.getColumnIndex('Group')
    , display = oDataStore.getColumnIndex('Display')
    , use = oDataStore.getColumnIndex('Use')
    , groupCount = group>=0?oDataStore.columnValues[group].length:0
    , groupedJSON = group>=0?groupBy(oDataStore.json.rows,0):oDataStore.json.rows
;
if( oParameter && ( oParameter.values.length > 0 ) ){
    for(var i=0;i<oParameter.values.length;++i){
      preselectedVals.push(oParameter.values[i].use)
    }
  }; 

  if(group>=0){
    for(var i=0;i<groupCount;++i){
      solJSON[i]={};
      solJSON[i]['type']='optiongroup';
      solJSON[i]['label']=oDataStore.columnValues[group][i];
      solJSON[i]['children'] = [];
      for(var j=0;j<groupedJSON[i].length;++j){
        solJSON[i]['children'][j]={};
        solJSON[i]['children'][j]['type']='option';
        solJSON[i]['children'][j]['value']=oDataStore.columnValues[use][groupedJSON[i][j][use]];
        solJSON[i]['children'][j]['label']=oDataStore.columnValues[display][groupedJSON[i][j][display]];
        if(preselectedVals && $.inArray(oDataStore.columnValues[use][groupedJSON[i][j][use]].toString(),preselectedVals)>=0) solJSON[i]['children'][j]['selected']='true';
      }
    }
  }
  else {
    for(var i=0;i<groupedJSON.length;++i){
      solJSON[i]={};
      solJSON[i]['type']='option';
      solJSON[i]['value']=oDataStore.columnValues[use][groupedJSON[i][use]];
      solJSON[i]['label']=oDataStore.columnValues[display][groupedJSON[i][display]];
      if(preselectedVals && $.inArray(oDataStore.columnValues[use][groupedJSON[i][use]].toString(),preselectedVals)>=0) solJSON[i]['selected']='true';
    }
  };
    

  this.data = solJSON;
	
};


searchList.prototype.getParameters = function()
{

  var sel=this.sel, vals, valLen, paramJSON=[];

  require(["/include/js/sol.js"],
    function(){
      vals = $(sel).searchableOptionList().getSelection();
      valLen = vals?vals.length:0;
      for (var i=0;i<valLen;++i){
        paramJSON.push({'use':vals[i].value.toString(),'display':vals[i].nextSibling.innerText})
      };
}()) //it looks like the function runs AFTER the rest of the outside function. This forces it to be run in sequence. 

return [{
		"parameter": this.param,
		"values": paramJSON,
	}];     
};

return searchList;
});